#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    checkError(setvbuf(stdout, NULL, _IOFBF, 0) == 0, "setvbuf");

    int fd = open(argv[1], O_WRONLY | O_TRUNC | O_CREAT, 0644);
    checkError(fd != -1, "open");

    printf("Neka poruka\n");

    int oldFd = dup(STDOUT_FILENO);
    checkError(oldFd != -1, "dup");

    checkError(dup2(fd, STDOUT_FILENO) != -1, "dup2");
    printf("Ovo ce ici u fajl\n");

    checkError(dup2(oldFd, STDOUT_FILENO) != -1, "dup2");
    printf("Ide na terminal\n");

    close(fd);

    exit(EXIT_SUCCESS);
}