#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

extern char** environ;

void print_env() {

    char** tmp;
    for (tmp = environ; *tmp != NULL; tmp++) {
        printf("%s\n", *tmp);
    }    
}

// ./a.out -[gsu] key value
int main(int argc, char** argv) {

    //print_env();
    checkError(argc >= 3, "args");

    if (strcmp(argv[1], "-g") == 0) {

        char* value = getenv(argv[2]);
        checkError(value != NULL, "getenv");
        printf("%s\n", value);
    }
    else if (strcmp(argv[1], "-s") == 0) {

        checkError(setenv(argv[2], argv[3], 1) != -1, "setenv");

        char* value = getenv(argv[2]);
        checkError(value != NULL, "getenv");
        printf("%s\n", value);
    }
    else if (strcmp(argv[1], "-u") == 0) {

        checkError(unsetenv(argv[2]) != -1, "unsetenv");

        char* value = getenv(argv[2]);
        if (value != NULL) {
            printf("Ne postoji\n");
        }
    }

    exit(EXIT_SUCCESS);
}