#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

// ./a.out filePath r|w
int main(int argc, char** argv) {

    //print_env();
    checkError(argc == 3, "args");

    int fd = open(argv[1], O_RDWR);
    checkError(fd != -1, "open");

    struct flock lock;
    lock.l_type = argv[2][0] == 'r' ? F_RDLCK : F_WRLCK;
    lock.l_start = 0;
    lock.l_len = 0;
    lock.l_whence = SEEK_SET;

    checkError(fcntl(fd, F_SETLK, &lock) != -1, "fcntl");

    sleep(30);

    lock.l_type = F_UNLCK;
    checkError(fcntl(fd, F_SETLK, &lock) != -1, "fcntl");

    close(fd);

    exit(EXIT_SUCCESS);
}