#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <errno.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

// ./a.out filePath start broj r|w vreme
int main(int argc, char** argv) {

    //print_env();
    checkError(argc == 6, "args");

    int fd = open(argv[1], O_RDWR);
    checkError(fd != -1, "open");

    int start = atoi(argv[2]);
    int broj = atoi(argv[3]);
    int vreme = atoi(argv[5]);

    struct flock lock;
    lock.l_type = argv[4][0] == 'r' ? F_RDLCK : F_WRLCK;
    lock.l_start = start;
    lock.l_len = broj;
    lock.l_whence = SEEK_SET;

    //checkError(fcntl(fd, F_SETLK, &lock) != -1, "fcntl");

    if (fcntl(fd, F_SETLK, &lock) == -1) {

        if (errno != EACCES && errno != EAGAIN) {
            checkError(0, "fcntl");
        }

        fcntl(fd, F_GETLK, &lock);
        printf("Resurs zakljucan (%d): %c\n", 
                (int)lock.l_pid ,lock.l_type == F_RDLCK ? 'r' : 'w');
    }
    else {
        sleep(vreme);

        lock.l_type = F_UNLCK;
        checkError(fcntl(fd, F_SETLK, &lock) != -1, "fcntl");
    }
    close(fd);

    exit(EXIT_SUCCESS);
}